package com.xiaoniu.subsystem.business.service.impl;

import com.alibaba.nacos.common.utils.CollectionUtils;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.xiaoniu.common.core.exception.ServiceException;
import com.xiaoniu.common.core.utils.StringUtils;
import com.xiaoniu.common.core.utils.bean.BeanValidators;
import com.xiaoniu.subsystem.business.domain.Flight;
import com.xiaoniu.subsystem.business.domain.SatisfactionSurvey;
import com.xiaoniu.subsystem.business.domain.Sign;
import com.xiaoniu.subsystem.business.mapper.SatisfactionSurveyMapper;
import com.xiaoniu.subsystem.business.service.IFlightService;
import com.xiaoniu.subsystem.business.service.ISatisfactionSurveyService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.xiaoniu.subsystem.system.domain.Unit;
import com.xiaoniu.subsystem.system.service.IUnitService;
import jakarta.validation.Validator;
import org.springframework.stereotype.Service;

import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

import static com.xiaoniu.common.security.utils.SecurityUtils.getUnitId;
import static com.xiaoniu.common.security.utils.SecurityUtils.getUserId;

/**
 * <p>
 * 满意度调查表 服务实现类
 * </p>
 *
 * @author haoxuyang
 * @since 2025-01-02 10:54:56
 */
@Service
public class SatisfactionSurveyServiceImpl extends ServiceImpl<SatisfactionSurveyMapper, SatisfactionSurvey> implements ISatisfactionSurveyService {
    protected final Validator validator;
    protected final IUnitService unitService;
    protected final IFlightService flightService;

    public SatisfactionSurveyServiceImpl(Validator validator, IUnitService unitService, IFlightService flightService) {
        this.validator = validator;
        this.unitService = unitService;
        this.flightService = flightService;
    }

    @Override
    public String importData(List<SatisfactionSurvey> list, boolean isUpdateSupport) {
        if (CollectionUtils.isEmpty(list)) {
            throw new ServiceException("导入满意度调查数据不能为空！");
        }
        int successNum = 0;
        int failureNum = 0;
        Map<String, Long> map = new HashMap<String, Long>();
        Map<String, Long> map1 = new HashMap<String, Long>();
        StringBuilder successMsg = new StringBuilder();
        StringBuilder failureMsg = new StringBuilder();
        Unit unit = unitService.getById(getUnitId());
        List<Unit> unitList = unitService.list();
        List<Unit> units =
                unitList.stream().filter(u -> StringUtils.equals("0", u.getType())).collect(Collectors.toList());
        if (CollectionUtils.isNotEmpty(units)) {
            map.putAll(units.stream().collect(Collectors.toMap(Unit::getUnitName, Unit::getUnitId)));
        }
        List<Unit> units1 =
                unitList.stream().filter(u -> StringUtils.equals("1", u.getType())).collect(Collectors.toList());
        if (CollectionUtils.isNotEmpty(units1)) {
            map1.putAll(units1.stream().collect(Collectors.toMap(Unit::getUnitName, Unit::getUnitId)));
        }
        for (SatisfactionSurvey d : list) {
            try {
                //查询班次是否存在
                Flight flight = flightService.getOne(new LambdaQueryWrapper<Flight>()
                        .eq(Flight::getFlightName, d.getFlightName())
                        .eq(Flight::getYear, d.getYear())
                        .eq(Flight::getTrainingTime, d.getTrainingTime())
                );
                if (flight != null) {
                    d.setFlightId(flight.getFlightId());
                }
                BeanValidators.validateWithException(validator, d);
                d.setCreateUser(getUserId());
                d.setCreateDept(unit.getUnitId());
                d.setCreateTime(new Date());
                //计算合计
                Integer courseArrangementSatisfaction = Integer.valueOf(d.getCourseArrangementSatisfaction());
                Integer dailySupportSatisfaction = Integer.valueOf(d.getDailySupportSatisfaction());
                Integer teachingAttitudeSatisfaction = Integer.valueOf(d.getTeachingAttitudeSatisfaction());
                Integer teachingContentSatisfaction = Integer.valueOf(d.getTeachingContentSatisfaction());
                Integer teachingMethodSatisfaction = Integer.valueOf(d.getTeachingMethodSatisfaction());
                Integer total = courseArrangementSatisfaction + dailySupportSatisfaction + teachingAttitudeSatisfaction + teachingContentSatisfaction + teachingMethodSatisfaction;
                String totalScore = total.toString();
                d.setTotalScore(totalScore);

                this.save(d);
                successNum++;
                successMsg.append("<br/>" + successNum + "、" + " 班次" + d.getFlightName() + " 满意度调查" + "导入成功");

            } catch (Exception e) {
                failureNum++;
                String msg = "<br/>" + failureNum + "、" + " 班次 " + d.getFlightName() + " 签到信息" + " 导入失败：";
                failureMsg.append(msg + e.getMessage());
                log.error(msg, e);
            }
        }
        if (failureNum > 0) {
            failureMsg.insert(0, "很抱歉，导入失败！共 " + failureNum + " 条数据格式不正确，错误如下：");
            throw new ServiceException(failureMsg.toString());
        } else {
            successMsg.insert(0, "恭喜您，数据已全部导入成功！共 " + successNum + " 条，数据如下：");
        }
        return successMsg.toString();
    }
}
